@mixin add-loader-color($color) {
  svg {

    path,
    line {
      stroke: $color;
    }
  }
}

@mixin button-styles($button-palette) {
  $border-radius: map-get($button-palette, "border-radius");
  
  // PRIMARY
  $filled-primary-color: map-get($button-palette, "filled-primary-color");
  $filled-primary-bg-color: map-get($button-palette, "filled-primary-bg-color");
  $filled-primary-hover-background-color: map-get($button-palette, "filled-primary-hover-bg-color");

  // LIGHT PRIMARY
  $filled-light-primary-color: map-get($button-palette, "filled-light-primary-color");
  $filled-light-primary-background-color: map-get($button-palette, "filled-light-primary-bg-color");
  $filled-light-primary-hover-background-color: map-get($button-palette, "filled-light-primary-hover-bg-color");

  // DARK PRIMARY
  $filled-dark-primary-color: map-get($button-palette, "filled-dark-primary-color");
  $filled-dark-primary-background-color: map-get($button-palette, "filled-dark-primary-bg-color");
  $filled-dark-primary-hover-background-color: map-get($button-palette, "filled-dark-primary-hover-bg-color");

  // WHITE PRIMARY
  $filled-white-primary-color: map-get($button-palette, "filled-white-primary-color");
  $filled-white-primary-background-color: map-get($button-palette, "filled-white-primary-bg-color");
  $filled-white-primary-hover-background-color: map-get($button-palette, "filled-white-primary-hover-bg-color");

  $filled-secondary-color: map-get($map: $button-palette, $key: "filled-secondary-color");

  $filled-confirm-color: map-get($map: $button-palette, $key: "filled-confirm-color");

  $filled-warning-color: map-get($map: $button-palette, $key: "filled-warning-color");

  $filled-error-color: map-get($map: $button-palette, $key: "filled-error-color");

  $filled-discard-color: map-get($button-palette, "filled-discard-color");

  // OUTLINE
  $outline-neutral-color: map-get($map: $button-palette, $key: "outline-neutral-color");
  $outline-neutral-bg-color: map-get($map: $button-palette, $key: "outline-neutral-bg-color");
  $outline-neutral-border-color: map-get($map: $button-palette, $key: "outline-neutral-border-color");

  .noku-library-button {
    &.basic {
      // Basic common style
      font-family: inherit;
      position: relative;
      transition: background-color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms,
        box-shadow 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms, border 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;
      padding: 0.5em 1em;
      font-size: 0.875rem;
      font-weight: 500;
      line-height: 1.75;
      border-radius: $border-radius;
    }

    // Sizes
    &.small {
      padding: 0.5em;

      .icon {
        font-size: 1em;

        &.start-icon {
          margin-right: 0.25em;
        }

        &.end-icon {
          margin-left: 0.25em;
        }
      }
    }

    // Filled style
    &.filled {

      // Primary filled button
      &.primary {
        background: $filled-primary-bg-color;
        color: $filled-primary-color;
        @include add-loader-color($filled-primary-color);

        &:hover {
          background-color: $filled-primary-hover-background-color;
        }
      }

      // Light Primary filled button
      &.light-primary {
        background-color: $filled-light-primary-background-color;
        color: $filled-light-primary-color;
        @include add-loader-color($filled-light-primary-color);

        &:hover {
          background-color: $filled-light-primary-hover-background-color;
        }
      }

      // Dark Primary filled button
      &.dark-primary {
        background-color: $filled-dark-primary-background-color;
        color: $filled-dark-primary-color;
        @include add-loader-color($filled-dark-primary-color);

        &:hover {
          background-color: $filled-dark-primary-hover-background-color;
        }
      }

      // Light Primary filled button
      &.white-primary {
        background-color: $filled-white-primary-background-color;
        color: $filled-white-primary-color;
        @include add-loader-color($filled-white-primary-color);

        &:hover {
          background-color: $filled-white-primary-hover-background-color;
        }
      }

      // Secondary filled button: missing for now
      &.secondary {
        background: map-get($button-palette, "filled-secondary-bg-color");
        color: $filled-secondary-color;
        @include add-loader-color($filled-secondary-color);

        &:hover {
          background-color: map-get($button-palette, "filled-secondary-hover-bg-color");
        }
      }

      // Confirm filled button
      &.confirm {
        background-color: map-get($button-palette, "filled-confirm-bg-color");
        color: $filled-confirm-color;
        @include add-loader-color($filled-confirm-color);

        &:hover {
          background-color: map-get($button-palette, "filled-confirm-hover-bg-color");
        }
      }

      // Warning filled button
      &.warning {
        background-color: map-get($button-palette, "filled-warning-bg-color");
        color: $filled-warning-color;
        @include add-loader-color($filled-warning-color);

        &:hover {
          background-color: map-get($button-palette, "filled-warning-hover-bg-color");
        }
      }

      // Error filled button
      &.error {
        background-color: map-get($button-palette, "filled-error-bg-color");
        color: $filled-error-color;
        @include add-loader-color($filled-error-color);

        &:hover {
          background-color: map-get($button-palette, "filled-error-hover-bg-color");
        }
      }

      // Discard filled button
      &.discard {
        background-color: map-get($button-palette, "filled-discard-bg-color");
        color: $filled-discard-color;
        @include add-loader-color($filled-discard-color);

        &:hover {
          background-color: map-get($button-palette, "filled-discard-hover-bg-color");
        }
      }

      // Reversed primary filled button (use when contrast with primary color is needed)
      &.reverse-primary {
        background-color: #ffffff;
        color: map-get($button-palette, "filled-primary-bg-color");

        &:hover {
          background-color: darken($color: #ffffff, $amount: 0.15);
        }
      }

      // Gradient filled button
      &.gradient {
        background: map-get($map: $button-palette, $key: "filled-gradient-bg-color");
        box-shadow: 0px 1px 3px rgba(0, 0, 0, 0.3);
        color: map-get($map: $button-palette, $key: "filled-gradient-color");
        z-index: 9;

        &::after {
          content: "";
          position: absolute;
          z-index: -1;
          top: 0;
          left: 0;
          width: 100%;
          height: 100%;
          opacity: 0;
          background: map-get($map: $button-palette, $key: "filled-gradient-hover-bg-color");
          transition: opacity 0.2s linear;
          border-radius: $border-radius;
        }

        &:hover::after {
          opacity: 1;
        }
      }
    }

    // Outlined style
    &.outlined {

      // Primary outlined button
      &.primary {
        background-color: map-get($button-palette, "outline-bg-color");
        color: map-get($button-palette, "outline-color");
        border: 1px solid map-get($button-palette, "outline-color");

        &:hover {
          background-color: rgba($color: black, $alpha: 0.15);
        }
      }

      &.light-primary {
        background-color: $filled-light-primary-background-color;
        border: 1px solid $filled-light-primary-color;
        color: $filled-light-primary-color;
        @include add-loader-color($filled-light-primary-color);

        &:hover {
          background-color: $filled-light-primary-hover-background-color;
        }
      }

      &.neutral {
        background-color: $outline-neutral-bg-color;
        color: $outline-neutral-color;
        border: 1px solid $outline-neutral-border-color;

        &:hover {
          background-color: rgba($color: black, $alpha: 0.05);
        }
      }

      // Secondary, Confirm, Discard are missing for now
    }

    // Flat style
    &.flat {

      // Primary flat button
      &.primary {
        color: map-get($button-palette, "outline-color");

        &:hover {
          background-color: rgba($color: black, $alpha: 0.15);
        }
      }

      // Reversed primary filled button (use when contrast with primary color is needed)
      &.reverse-primary {
        color: #ffffff;

        &:hover {
          background-color: rgba($color: black, $alpha: 0.15);
        }
      }

      // Secondary, Confirm, Discard are missing for now
    }

    &.shadow {
      box-shadow: 0px 3px 1px -2px rgba(0, 0, 0, 0.2), 0px 2px 2px 0px rgba(0, 0, 0, 0.14),
        0px 1px 5px 0px rgba(0, 0, 0, 0.12);
    }

    // Disabled
    &.disabled {
      opacity: 0.3;
      cursor: default;
    }

    // Loading
    &.loading {
      cursor: progress;

      .loader {
        box-sizing: border-box;
        margin-left: 1em;
        max-height: 24px;
      }
    }

    // Uppercase
    &.uppercase {
      text-transform: uppercase;
    }

    // Fluid - Full Width
    &.fluid {
      min-height: 40px;
      font-weight: 700;
      width: 100%;
    }

    &.round {
      border-radius: 40px;
    }

    &.no-wrap {
      white-space: nowrap;
    }

    // Link
    .link {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
    }

    // Button icons
    .icon {
      color: inherit;
      font-size: 1.25em;

      &.start-icon {
        margin-right: 1em;
      }

      &.end-icon {
        margin-left: 1em;
      }
    }
  }
}